<template>
	<q-layout view="hHh lpR fff">
		<q-header class="main-header q-py-sm shadow-5">
			<div class="row justify-between q-px-md items-center q-gutter-y-md">
				<div
					id="logo"
					class="text-h5 row items-center cursor-pointer"
					@click="routerPush('/')"
				>
					<q-avatar size="55px" square class="q-mr-md">
						<img src="~assets/images/pikachu.png" />
					</q-avatar>
					<pokedex />
				</div>
				<q-input
					hide-bottom-space
					id="searchInput"
					class="col-12 col-sm-4"
					input-class=" q-px-md"
					dense
					@keyup.enter="onSearch"
					v-model="filter"
					bg-color="white"
					placeholder="Search by a name or number"
				>
					<template v-slot:append>
						<q-btn
							:disable="!filter"
							id="btnSearch"
							@click="onSearch"
							round
							dense
							flat
							icon="search"
						/>
					</template>
				</q-input>
			</div>
		</q-header>

		<q-page-container>
			<header-carousel class="carousel" v-if="$route.name === 'home'" />
			<router-view class="body-container" />
		</q-page-container>

		<page-footer />

		<img
			height="60%"
			width="60%"
			src="~assets/images/pikachu-bg.png"
			class="bg-image"
		/>
		<img src="~assets/images/pokeballs-bg.png" class="bg-upper-image" />

		<floating />
	</q-layout>
</template>

<script>
	import { routeManage } from "src/components/mixins/commonMixins";
	import { mapGetters, mapMutations } from "vuex";
	import PageFooter from "src/components/layouts/PageFooter.vue";
	import Pokedex from "src/components/typography/pokedex.vue";
	import HeaderCarousel from "src/components/layouts/HeaderCarousel.vue";
	import Floating from "src/components/button/floating.vue";

	export default {
		name: "MainLayout",
		components: { PageFooter, Pokedex, HeaderCarousel, Floating },
		mixins: [routeManage],
		data: () => ({}),

		methods: {
			...mapMutations("pokemon", ["updateSearch"]),
			onSearch() {
				if (!this.search) return false;
				let endpoint = this.search?.toLowerCase() ?? null;

				this.routerPush(`/pokemon/${endpoint}`);
			},
		},

		computed: {
			...mapGetters("pokemon", ["search"]),
			filter: {
				get() {
					return this.search;
				},

				set(value) {
					this.updateSearch(value?.toLowerCase() ?? null);
				},
			},
		},
	};
</script>

<style scoped lang="scss">
</style>
